Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 3211)
@@ -54,4 +54,9 @@
    
    INTEGER ::   nsbc   ! type of surface boundary condition (deduced from namsbc informations)
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
       
    !! * Substitutions
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90	(revision 3211)
@@ -54,11 +54,16 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   h_rnf               !: depth of runoff in m
    INTEGER,  PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   nk_rnf              !: depth of runoff in model levels
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   rnf_tsc_b, rnf_tsc  !: before and now T & S runoff contents   [K.m/s & PSU.m/s]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   rnf_tsc_b, rnf_tsc  !: before and now T & S runoff contents
+   !                                                                              !            [K.m/s & PSU.m/s]
    
    REAL(wp) ::   r1_rau0   ! = 1 / rau0 
 
    TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_rnf       ! structure: river runoff (file information, fields read)
-   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_s_rnf     ! structure: river runoff salinity (file information, fields read)  
-   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_t_rnf     ! structure: river runoff temperature (file information, fields read)  
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_s_rnf     ! structure: river runoff salinity (file info, fields read)  
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_t_rnf     ! structure: river runoff temperature (file info, fields read)  
+
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
  
    !! * Substitutions  
@@ -197,4 +202,5 @@
       !!----------------------------------------------------------------------
       REAL(wp), DIMENSION(:,:,:), INTENT(inout) ::   phdivn   ! horizontal divergence
+!FTRANS phdivn :I :I :z
       !!
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
@@ -238,4 +244,7 @@
    END SUBROUTINE sbc_rnf_div
 
+   !! * Reset control of array index permutation
+#  include "dom_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
 
    SUBROUTINE sbc_rnf_init
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssm.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssm.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssm.F90	(revision 3211)
@@ -14,5 +14,4 @@
    USE oce             ! ocean dynamics and tracers
    USE dom_oce         ! ocean space and time domain
-   USE sbc_oce         ! Surface boundary condition: ocean fields
    USE sbc_oce         ! surface boundary condition: ocean fields
    USE sbcapr          ! surface boundary condition: atmospheric pressure
@@ -26,4 +25,9 @@
 
    PUBLIC   sbc_ssm    ! routine called by step.F90
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
    
    !! * Substitutions
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssr.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssr.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssr.F90	(revision 3211)
@@ -41,4 +41,9 @@
    TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_sst   ! structure of input SST (file informations, fields read)
    TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_sss   ! structure of input SSS (file informations, fields read)
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
 
    !! * Substitutions
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SOL/solmat.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SOL/solmat.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SOL/solmat.F90	(revision 3211)
@@ -37,4 +37,9 @@
    PUBLIC   sol_mat    ! routine called by inisol.F90
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "obc_oce_ftrans.h90"
+
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
@@ -207,5 +212,9 @@
                !  south coefficient
                IF( ( nbondj == -1 .OR. nbondj == 2 ) .AND. ( jj == 3 ) ) THEN
+#if defined key_z_first
+                  zcoefs = -zcoef * hv(ji,jj-1) * e1v(ji,jj-1)/e2v(ji,jj-1)*(1.-vmask_1(ji,jj-1))
+#else
                   zcoefs = -zcoef * hv(ji,jj-1) * e1v(ji,jj-1)/e2v(ji,jj-1)*(1.-vmask(ji,jj-1,1))
+#endif
                ELSE
                   zcoefs = -zcoef * hv(ji,jj-1) * e1v(ji,jj-1)/e2v(ji,jj-1)
@@ -223,5 +232,9 @@
                !   east coefficient
                IF( ( nbondi == 1 .OR. nbondi == 2 ) .AND. ( ji == nlci-2 ) ) THEN
+#if defined key_z_first
+                  zcoefe = -zcoef * hu(ji,jj) * e2u(ji,jj)/e1u(ji,jj)*(1.-umask_1(ji,jj))
+#else
                   zcoefe = -zcoef * hu(ji,jj) * e2u(ji,jj)/e1u(ji,jj)*(1.-umask(ji,jj,1))
+#endif
                ELSE
                   zcoefe = -zcoef * hu(ji,jj) * e2u(ji,jj)/e1u(ji,jj)
@@ -231,5 +244,9 @@
                !   north coefficient
                IF( ( nbondj == 1 .OR. nbondj == 2 ) .AND. ( jj == nlcj-2 ) ) THEN
+#if defined key_z_first
+                  zcoefn = -zcoef * hv(ji,jj) * e1v(ji,jj)/e2v(ji,jj)*(1.-vmask_1(ji,jj))
+#else
                   zcoefn = -zcoef * hv(ji,jj) * e1v(ji,jj)/e2v(ji,jj)*(1.-vmask(ji,jj,1))
+#endif
                ELSE
                   zcoefn = -zcoef * hv(ji,jj) * e1v(ji,jj)/e2v(ji,jj)
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SOL/solpcg.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SOL/solpcg.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SOL/solpcg.F90	(revision 3211)
@@ -20,4 +20,8 @@
 
    PUBLIC   sol_pcg    ! 
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
 
    !! * Substitutions
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SOL/solsor.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SOL/solsor.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SOL/solsor.F90	(revision 3211)
@@ -28,4 +28,9 @@
 
    PUBLIC   sol_sor    ! 
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SOL/solver.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SOL/solver.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/SOL/solver.F90	(revision 3211)
@@ -29,4 +29,10 @@
 
    IMPLICIT NONE
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "obc_oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2.F90	(revision 3211)
@@ -61,4 +61,8 @@
 
    REAL(wp), PUBLIC ::   ralpbet              !: alpha / beta ratio
+
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
+#  include "zdfddm_ftrans.h90"
    
    !! * Substitutions
@@ -111,4 +115,9 @@
       USE wrk_nemo, ONLY:   zws => wrk_3d_1   ! 3D workspace
       !!
+
+!FTRANS zws :I :I :z
+!FTRANS pts :I :I :z :I
+!FTRANS prd :I :I :z
+
       REAL(wp), DIMENSION(:,:,:,:), INTENT(in   ) ::   pts   ! 1 : potential temperature  [Celcius]
       !                                                      ! 2 : salinity               [psu]
@@ -135,7 +144,13 @@
          zws(:,:,:) = SQRT( ABS( pts(:,:,:,jp_sal) ) )
          !  
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 1, jpj
                DO ji = 1, jpi
+#endif
                   zt = pts   (ji,jj,jk,jp_tem)
                   zs = pts   (ji,jj,jk,jp_sal)
@@ -178,12 +193,32 @@
          !
       CASE( 1 )                !==  Linear formulation function of temperature only  ==!
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+                  prd(ji,jj,jk) = ( 0.0285_wp - rn_alpha * pts(ji,jj,jk,jp_tem) ) * tmask(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 1, jpkm1
             prd(:,:,jk) = ( 0.0285_wp - rn_alpha * pts(:,:,jk,jp_tem) ) * tmask(:,:,jk)
          END DO
+#endif
          !
       CASE( 2 )                !==  Linear formulation function of temperature and salinity  ==!
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+                  prd(ji,jj,jk) = ( rn_beta  * pts(ji,jj,jk,jp_sal) - rn_alpha * pts(ji,jj,jk,jp_tem) ) * tmask(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 1, jpkm1
             prd(:,:,jk) = ( rn_beta  * pts(:,:,jk,jp_sal) - rn_alpha * pts(:,:,jk,jp_tem) ) * tmask(:,:,jk)
          END DO
+#endif
          !
       END SELECT
@@ -193,4 +228,10 @@
       IF( wrk_not_released(3, 1) )   CALL ctl_stop('eos_insitu: failed to release workspace array')
       !
+
+!! * Reset control of array index permutation
+!FTRANS CLEAR
+#  include "dom_oce_ftrans.h90"
+#  include "zdfddm_ftrans.h90"
+
    END SUBROUTINE eos_insitu
 
@@ -245,8 +286,19 @@
       USE wrk_nemo, ONLY:   zws => wrk_3d_1 ! 3D workspace
       !!
-      REAL(wp), DIMENSION(jpi,jpj,jpk,jpts), INTENT(in   ) ::   pts    ! 1 : potential temperature  [Celcius]
-      !                                                                ! 2 : salinity               [psu]
-      REAL(wp), DIMENSION(jpi,jpj,jpk     ), INTENT(  out) ::   prd    ! in situ density            [-]
-      REAL(wp), DIMENSION(jpi,jpj,jpk     ), INTENT(  out) ::   prhop  ! potential density (surface referenced)
+
+!FTRANS zws :I :I :z
+!FTRANS pts :I :I :z :I
+!FTRANS prd :I :I :z
+!FTRANS prhop :I :I :z
+
+!!DCSE NEMO: This style defeats ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,jpts), INTENT(in   ) ::   pts    ! 1 : potential temperature  [Celcius]
+!     !                                                                ! 2 : salinity               [psu]
+!     REAL(wp), DIMENSION(jpi,jpj,jpk     ), INTENT(  out) ::   prd    ! in situ density            [-]
+!     REAL(wp), DIMENSION(jpi,jpj,jpk     ), INTENT(  out) ::   prhop  ! potential density (surface referenced)
+      REAL(wp), INTENT(in   ) ::   pts(jpi,jpj,jpk,jpts)   ! 1 : potential temperature  [Celcius]
+      !                                                    ! 2 : salinity               [psu]
+      REAL(wp), INTENT(  out) ::   prd(jpi,jpj,jpk)        ! in situ density            [-]
+      REAL(wp), INTENT(  out) ::   prhop(jpi,jpj,jpk)      ! potential density (surface referenced)
       !
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
@@ -266,7 +318,13 @@
          zws(:,:,:) = SQRT( ABS( pts(:,:,:,jp_sal) ) )
          !  
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 1, jpj
                DO ji = 1, jpi
+#endif
                   zt = pts   (ji,jj,jk,jp_tem)
                   zs = pts   (ji,jj,jk,jp_sal)
@@ -312,14 +370,36 @@
          !
       CASE( 1 )                !==  Linear formulation = F( temperature )  ==!
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+                  prd  (ji,jj,jk) = ( 0.0285_wp - rn_alpha * pts(ji,jj,jk,jp_tem) )        * tmask(ji,jj,jk)
+                  prhop(ji,jj,jk) = ( 1.e0_wp   +            prd(ji,jj,jk)        ) * rau0 * tmask(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 1, jpkm1
             prd  (:,:,jk) = ( 0.0285_wp - rn_alpha * pts(:,:,jk,jp_tem) )        * tmask(:,:,jk)
             prhop(:,:,jk) = ( 1.e0_wp   +            prd (:,:,jk)       ) * rau0 * tmask(:,:,jk)
          END DO
+#endif
          !
       CASE( 2 )                !==  Linear formulation = F( temperature , salinity )  ==!
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+                  prd  (ji,jj,jk) = ( rn_beta  * pts(ji,jj,jk,jp_sal) - rn_alpha * pts(ji,jj,jk,jp_tem) )        * tmask(ji,jj,jk)
+                  prhop(ji,jj,jk) = ( 1.e0_wp  + prd(ji,jj,jk)                                          ) * rau0 * tmask(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 1, jpkm1
             prd  (:,:,jk) = ( rn_beta  * pts(:,:,jk,jp_sal) - rn_alpha * pts(:,:,jk,jp_tem) )        * tmask(:,:,jk)
             prhop(:,:,jk) = ( 1.e0_wp  + prd (:,:,jk) )                                       * rau0 * tmask(:,:,jk)
          END DO
+#endif
          !
       END SELECT
@@ -329,4 +409,10 @@
       IF( wrk_not_released(3, 1) )   CALL ctl_stop('eos_insitu_pot: failed to release workspace array')
       !
+
+!! * Reset control of array index permutation
+!FTRANS CLEAR
+#  include "dom_oce_ftrans.h90"
+#  include "zdfddm_ftrans.h90"
+
    END SUBROUTINE eos_insitu_pot
 
@@ -400,5 +486,9 @@
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
+#if defined key_z_first
+               zmask = tmask_1(ji,jj)          ! land/sea bottom mask = surf. mask
+#else
                zmask = tmask(ji,jj,1)          ! land/sea bottom mask = surf. mask
+#endif
                zt    = pts  (ji,jj,jp_tem)            ! interpolated T
                zs    = pts  (ji,jj,jp_sal)            ! interpolated S
@@ -442,5 +532,9 @@
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
+#if defined key_z_first
+               prd(ji,jj) = ( 0.0285_wp - rn_alpha * pts(ji,jj,jp_tem) ) * tmask_1(ji,jj)
+#else
                prd(ji,jj) = ( 0.0285_wp - rn_alpha * pts(ji,jj,jp_tem) ) * tmask(ji,jj,1)
+#endif
             END DO
          END DO
@@ -449,5 +543,9 @@
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
+#if defined key_z_first
+               prd(ji,jj) = ( rn_beta * pts(ji,jj,jp_sal) - rn_alpha * pts(ji,jj,jp_tem) ) * tmask_1(ji,jj) 
+#else
                prd(ji,jj) = ( rn_beta * pts(ji,jj,jp_sal) - rn_alpha * pts(ji,jj,jp_tem) ) * tmask(ji,jj,1) 
+#endif
             END DO
          END DO
@@ -492,7 +590,16 @@
       !! References :   McDougall, J. Phys. Oceanogr., 17, 1950-1964, 1987.
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj,jpk,jpts), INTENT(in   ) ::   pts   ! 1 : potential temperature  [Celcius]
-      !                                                               ! 2 : salinity               [psu]
-      REAL(wp), DIMENSION(jpi,jpj,jpk)     , INTENT(  out) ::   pn2   ! Brunt-Vaisala frequency    [s-1]
+
+!FTRANS pts :I :I :z :I
+!FTRANS pn2 :I :I :z
+
+!!DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,jpts), INTENT(in   ) ::   pts   ! 1 : potential temperature  [Celcius]
+!     !                                                               ! 2 : salinity               [psu]
+!     REAL(wp), DIMENSION(jpi,jpj,jpk)     , INTENT(  out) ::   pn2   ! Brunt-Vaisala frequency    [s-1]
+
+      REAL(wp), INTENT(in   ) ::   pts(jpi,jpj,jpk,jpts)   ! 1 : potential temperature  [Celcius]
+      !                                                    ! 2 : salinity               [psu]
+      REAL(wp), INTENT(  out) ::   pn2(jpi,jpj,jpk)        ! Brunt-Vaisala frequency    [s-1]
       !!
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
@@ -509,7 +616,13 @@
       !
       CASE( 0 )                !==  Jackett and McDougall (1994) formulation  ==!
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 2, jpkm1
+#else
          DO jk = 2, jpkm1
             DO jj = 1, jpj
                DO ji = 1, jpi
+#endif
                   zgde3w = grav / fse3w(ji,jj,jk)
                   zt = 0.5 * ( pts(ji,jj,jk,jp_tem) + pts(ji,jj,jk-1,jp_tem) )         ! potential temperature at w-pt
@@ -556,9 +669,31 @@
          !
       CASE( 1 )                !==  Linear formulation = F( temperature )  ==!
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 2, jpkm1
+                  pn2(ji,jj,jk) = grav * rn_alpha * ( pts(ji,jj,jk-1,jp_tem) - pts(ji,jj,jk,jp_tem) ) &
+                     &                 / fse3w(ji,jj,jk) * tmask(ji,jj,jk)
+               END DO
+            END DO
+         END DO
+#else
          DO jk = 2, jpkm1
             pn2(:,:,jk) = grav * rn_alpha * ( pts(:,:,jk-1,jp_tem) - pts(:,:,jk,jp_tem) ) / fse3w(:,:,jk) * tmask(:,:,jk)
          END DO
+#endif
          !
       CASE( 2 )                !==  Linear formulation = F( temperature , salinity )  ==!
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 2, jpkm1
+                  pn2(ji,jj,jk) = grav * (  rn_alpha * ( pts(ji,jj,jk-1,jp_tem) - pts(ji,jj,jk,jp_tem) )      &
+                     &                    - rn_beta  * ( pts(ji,jj,jk-1,jp_sal) - pts(ji,jj,jk,jp_sal) )  )   &
+                     &                 / fse3w(ji,jj,jk) * tmask(ji,jj,jk)
+               END DO
+            END DO
+         END DO 
+#else
          DO jk = 2, jpkm1
             pn2(:,:,jk) = grav * (  rn_alpha * ( pts(:,:,jk-1,jp_tem) - pts(:,:,jk,jp_tem) )      &
@@ -566,8 +701,15 @@
                &               / fse3w(:,:,jk) * tmask(:,:,jk)
          END DO 
+#endif
 #if defined key_zdfddm
+#if defined key_z_first
+         DO jj = 1, jpj                                   ! Rrau = (alpha / beta) (dk[t] / dk[s])
+            DO ji = 1, jpi
+               DO jk = 2, jpkm1
+#else
          DO jk = 2, jpkm1                                 ! Rrau = (alpha / beta) (dk[t] / dk[s])
             DO jj = 1, jpj
                DO ji = 1, jpi
+#endif
                   zds = ( pts(ji,jj,jk-1,jp_sal) - pts(ji,jj,jk,jp_sal) )  
                   IF ( ABS( zds ) <= 1.e-20_wp ) zds = 1.e-20_wp
@@ -584,4 +726,10 @@
 #endif
       !
+
+!! * Reset control of array index permutation
+!FTRANS CLEAR
+#  include "dom_oce_ftrans.h90"
+#  include "zdfddm_ftrans.h90"
+
    END SUBROUTINE eos_bn2
 
@@ -609,6 +757,14 @@
       !! ** Action  : - palph, pbeta : thermal and haline expansion coeff. at T-point
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj,jpk,jpts), INTENT(in   ) ::   pts            ! pot. temperature & salinity
-      REAL(wp), DIMENSION(jpi,jpj,jpk)     , INTENT(  out) ::   palph, pbeta   ! thermal & haline expansion coeff.
+
+!FTRANS pts :I :I :z :I
+!FTRANS palph :I :I :z
+!FTRANS pbeta :I :I :z
+!!DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,jpts), INTENT(in   ) ::   pts            ! pot. temperature & salinity
+!     REAL(wp), DIMENSION(jpi,jpj,jpk)     , INTENT(  out) ::   palph, pbeta   ! thermal & haline expansion coeff.
+      REAL(wp), INTENT(in   ) ::   pts(jpi,jpj,jpk,jpts)            ! pot. temperature & salinity
+      REAL(wp), INTENT(  out) ::   palph(jpi,jpj,jpk)               ! thermal expansion coeff.
+      REAL(wp), INTENT(  out) ::   pbeta(jpi,jpj,jpk)               ! haline  expansion coeff.
       !
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
@@ -619,7 +775,13 @@
       !
       CASE ( 0 )               ! Jackett and McDougall (1994) formulation
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               DO jk = 1, jpk
+#else
          DO jk = 1, jpk
             DO jj = 1, jpj
                DO ji = 1, jpi
+#endif
                   zt = pts(ji,jj,jk,jp_tem)           ! potential temperature
                   zs = pts(ji,jj,jk,jp_sal) - 35._wp  ! salinity anomaly (s-35)
@@ -670,4 +832,10 @@
       END SELECT
       !
+
+!! * Reset control of array index permutation
+!FTRANS CLEAR
+#  include "dom_oce_ftrans.h90"
+#  include "zdfddm_ftrans.h90"
+
    END SUBROUTINE eos_alpbet
 
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traadv.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traadv.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traadv.F90	(revision 3211)
@@ -44,4 +44,9 @@
    INTEGER ::   nadv   ! choice of the type of advection scheme
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -64,8 +69,12 @@
       USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY:   zun => wrk_3d_1 , zvn => wrk_3d_2 , zwn => wrk_3d_3   ! 3D workspace
+
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zun zvn zwn :I :I :z
+
       !
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
       !
-      INTEGER ::   jk   ! dummy loop index
+      INTEGER ::   ji, jj, jk   ! dummy loop index
       !!----------------------------------------------------------------------
       !
@@ -83,4 +92,18 @@
       !
       !                                               !==  effective transport  ==!
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk = 1, jpkm1
+               zun(ji,jj,jk) = e2u(ji,jj) * fse3u(ji,jj,jk) * un(ji,jj,jk)     ! eulerian transport only
+               zvn(ji,jj,jk) = e1v(ji,jj) * fse3v(ji,jj,jk) * vn(ji,jj,jk)
+               zwn(ji,jj,jk) = e1t(ji,jj) * e2t(ji,jj)      * wn(ji,jj,jk)
+            END DO
+            zun(ji,jj,jpk) = 0._wp                                             ! no transport trough the bottom
+            zvn(ji,jj,jpk) = 0._wp                                             ! no transport trough the bottom
+            zwn(ji,jj,jpk) = 0._wp                                             ! no transport trough the bottom
+         END DO
+      END DO
+#else
       DO jk = 1, jpkm1
          zun(:,:,jk) = e2u(:,:) * fse3u(:,:,jk) * un(:,:,jk)                  ! eulerian transport only
@@ -91,4 +114,5 @@
       zvn(:,:,jpk) = 0._wp                                                     ! no transport trough the bottom
       zwn(:,:,jpk) = 0._wp                                                     ! no transport trough the bottom
+#endif
       !
       IF( lk_traldf_eiv .AND. .NOT. ln_traldf_grif )   &
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_cen2.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_cen2.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_cen2.F90	(revision 3211)
@@ -43,4 +43,11 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) :: upsmsk !: mixed upstream/centered scheme near some straits 
    !                                                             !  and in closed seas (orca 2 and 4 configurations)
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "trc_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -114,11 +121,24 @@
       USE wrk_nemo, ONLY:   zwz => wrk_3d_1 , zind => wrk_3d_2   ! 3D workspace
       USE wrk_nemo, ONLY:   ztfreez => wrk_2d_1                  ! 2D     -
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zwx zwy zwz zind :I :I :z
       !
       INTEGER                              , INTENT(in   ) ::   kt              ! ocean time-step index
       CHARACTER(len=3)                     , INTENT(in   ) ::   cdtype          ! =TRA or TRC (tracer indicator)
       INTEGER                              , INTENT(in   ) ::   kjpt            ! number of tracers
-      REAL(wp), DIMENSION(jpi,jpj,jpk     ), INTENT(in   ) ::   pun, pvn, pwn   ! 3 ocean velocity components
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb, ptn        ! before and now tracer fields
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta             ! tracer trend 
+
+      !! DCSE_NEMO: This style defeats ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk     ), INTENT(in   ) ::   pun, pvn, pwn   ! 3 ocean velocity components
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb, ptn        ! before and now tracer fields
+!     REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta             ! tracer trend 
+
+!FTRANS pun pvn pwn :I :I :z
+      REAL(wp), INTENT(in   ) ::   pun(jpi,jpj,jpk)         ! ocean velocity component
+      REAL(wp), INTENT(in   ) ::   pvn(jpi,jpj,jpk)         ! ocean velocity component
+      REAL(wp), INTENT(in   ) ::   pwn(jpi,jpj,jpk)         ! ocean velocity component
+!FTRANS ptb ptn pta :I :I :z :
+      REAL(wp), INTENT(in   ) ::   ptb(jpi,jpj,jpk,kjpt)    ! tracer field (before)
+      REAL(wp), INTENT(in   ) ::   ptn(jpi,jpj,jpk,kjpt)    ! tracer field (now)
+      REAL(wp), INTENT(inout) ::   pta(jpi,jpj,jpk,kjpt)    ! tracer trend 
       !
       INTEGER  ::   ji, jj, jk, jn   ! dummy loop indices
@@ -164,7 +184,13 @@
 !!gm  not a big deal since cen2 is no more used in global ice-ocean simulations
       ztfreez(:,:) = tfreez( tsn(:,:,1,jp_sal) )
+#if defined key_z_first
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            DO jk = 1, jpk
+#else
       DO jk = 1, jpk
          DO jj = 1, jpj
             DO ji = 1, jpi
+#endif
                !                                        ! below ice covered area (if tn < "freezing"+0.1 )
                IF( tsn(ji,jj,jk,jp_tem) <= ztfreez(ji,jj) + 0.1 ) THEN   ;   zice = 1.e0
@@ -185,4 +211,9 @@
          !    ====================
          !
+#if defined key_z_first
+         DO jj = 1, jpjm1
+            DO ji = 1, fs_jpim1
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             !                        ! Second order centered tracer flux at u- and v-points
@@ -190,4 +221,5 @@
                !
                DO ji = 1, fs_jpim1   ! vector opt.
+#endif
                   ! upstream indicator
                   zcofi = MAX( zind(ji+1,jj,jk), zind(ji,jj,jk) )
@@ -221,7 +253,13 @@
          ENDIF
          !
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               DO jk = 2, jpk
+#else
          DO jk = 2, jpk              ! Second order centered tracer flux at w-point
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   ! upstream indicator
                   zcofk = MAX( zind(ji,jj,jk-1), zind(ji,jj,jk) ) 
@@ -240,7 +278,13 @@
          ! II. Divergence of advective fluxes
          ! ----------------------------------
+#if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               DO jk = 1, jpkm1
+#else
          DO jk = 1, jpkm1
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) *  fse3t(ji,jj,jk) )
                   ! advective trends
@@ -278,4 +322,12 @@
           wrk_not_released(3, 1,2) )   CALL ctl_stop('tra_adv_cen2: failed to release workspace arrays')
       !
+
+!! * Reset control of array index permutation
+!FTRANS CLEAR
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "trc_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+
    END SUBROUTINE tra_adv_cen2
    
